
;  GNU C 2.7.2 [AL 1.1, MM 40] RISC NEWS-OS compiled by CC

;  Cc1 defaults:
;  -mmemcpy

;  Cc1 arguments (-G value = 0, Cpu = 3000, ISA = 1):
;  -quiet -dumpbase -O2 -Wall -o

gcc2_compiled.:
__gnu_compiled_c:
; APP
	
	.code
	.align 1
	.global z80_run
z80_run:
	pushn %r3
	sub	%sp,0x1		; 	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; z80
	ext	0x30		; 	xld.w %r3, [%r0+48]		; z80->read
	ld.w	%r3,[%r0]
	ext	0x24		; 	xld.w [%r0+36], %r13		; CYCLE
	ld.w	[%r0],%r13
	cmp	%r13,0x0	; 	xcmp %r13, 0			; if(CYCLE <= 0) break
	jrle	z80_run_L50	; 	xjrle z80_run_L50
	;
z80_run_L10:
	ext	0x23		; 	xld.ub %r10, [%r0+35]		; if(HALT) break
	ld.ub	%r10,[%r0]
	cmp	%r10,0x0	; 	xcmp %r10, 0
	jrne	z80_run_L50	; 	xjrne z80_run_L50
	;
	ext	0x16		; 	xld.uh %r1, [%r0+22]		; PC
	ld.uh	%r1,[%r0]
	;
	ld.w %r12, %r0			; code = z80->read(z80, PC++)
	ld.uh %r13, %r1
	call.d %r3
	add %r1, 1			; *delay*
	ld.ub %r13, %r10
	;
	ext	z80_op_table+0x0@h	; 	xld.w %r2, z80_op_table		; op = &z80_op_table[code]
	ext	z80_op_table+0x0@m
	ld.w	%r2,z80_op_table+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r2, %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r2+4]		; argc == 0 ?
	ld.ub	%r10,[%r2]
	cmp	%r10,0x0	; 	xcmp %r10, 0	
	jreq	z80_run_L20	; 	xjreq z80_run_L20
	ld.b	[%sp+0x0],%r13	; 	xld.b [%sp+0], %r13		; (save code)
	;
	ld.w %r12, %r0			; arg1 = z80->read(z80, PC++)
	ld.uh %r13, %r1
	call.d %r3
	add %r1, 1			; *delay*
	ld.ub %r14, %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r2+4]		; argc == 1 ?
	ld.ub	%r10,[%r2]
	cmp	%r10,0x1	; 	xcmp %r10, 1	
	jreq	z80_run_L30	; 	xjreq z80_run_L30
	ld.b	[%sp+0x1],%r14	; 	xld.b [%sp+1], %r14		; (save arg1)
	;
	ld.w %r12, %r0			; arg2 = z80->read(z80, PC++)
	ld.w %r13, %r1
	call.d %r3
	add %r1, 1			; *delay*
	ld.ub %r15, %r10
	;
	ld.ub	%r14,[%sp+0x1]	; 	xld.ub %r14, [%sp+1]		; (restore arg1)
z80_run_L30:
	ld.ub	%r13,[%sp+0x0]	; 	xld.ub %r13, [%sp+0]		; (restore code)
z80_run_L20:
	;
	ld.w	%r10,[%r2]	; 	xld.w %r10, [%r2+0]		; op->proc(z80, code, arg1, arg2)
	ext	0x16		; 	xld.h [%r0+22], %r1		; PC *anti-interlock*
	ld.h	[%r0],%r1
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r2+5]
	ld.ub	%r11,[%r2]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	jrgt	z80_run_L10	; 	xjrgt z80_run_L10		; if(CYCLE <= 0) break
z80_run_L50:
	;
	add	%sp,0x1		; 	xadd %sp, %sp, 4
	popn %r3
	ret

	
	.code
	.align 1
	.global z80op_CB
z80op_CB:
	pushn %r2
	;
	ld.w %r0, %r12			; z80
	ext	0x16		; 	xld.uh %r1, [%r0+22]		; PC
	ld.uh	%r1,[%r0]
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; code = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r13, %r10
	;
	ext	z80_op_table_CB+0x0@h	; 	xld.w %r2, z80_op_table_CB	; op = &z80_op_table_CB[code]
	ext	z80_op_table_CB+0x0@m
	ld.w	%r2,z80_op_table_CB+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r2, %r10
	;
	ld.w	%r10,[%r2]	; 	xld.w %r10, [%r2+0]		; op->proc(z80, code, arg1, arg2)
	ext	0x16		; 	xld.h [%r0+22], %r1		; PC *anti-interlock*
	ld.h	[%r0],%r1
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r2+5]
	ld.ub	%r11,[%r2]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	;
	popn %r2
	ret

	
	.code
	.align 1
	.global z80op_ED
z80op_ED:
	pushn %r2
	sub	%sp,0x1		; 	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; z80
	ext	0x16		; 	xld.uh %r1, [%r0+22]		; PC
	ld.uh	%r1,[%r0]
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; code = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r13, %r10
	;
	ext	z80_op_table_ED+0x0@h	; 	xld.w %r2, z80_op_table_ED	; op = &z80_op_table_ED[code]
	ext	z80_op_table_ED+0x0@m
	ld.w	%r2,z80_op_table_ED+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r2, %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r2+4]		; argc == 0 ?
	ld.ub	%r10,[%r2]
	cmp	%r10,0x0	; 	xcmp %r10, 0	
	jreq	z80op_ED_L10	; 	xjreq z80op_ED_L10
	ld.b	[%sp+0x0],%r13	; 	xld.b [%sp+0], %r13		; (save code)
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; arg1 = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.b	[%sp+0x1],%r10	; 	xld.b [%sp+1], %r10		; (save arg1)
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; arg2 = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.w %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r15, %r10
	;
	ld.ub	%r14,[%sp+0x1]	; 	xld.ub %r14, [%sp+1]		; (restore arg1)
	ld.ub	%r13,[%sp+0x0]	; 	xld.ub %r13, [%sp+0]		; (restore code)
z80op_ED_L10:
	;
	ld.w	%r10,[%r2]	; 	xld.w %r10, [%r2+0]		; op->proc(z80, code, arg1, arg2)
	ext	0x16		; 	xld.h [%r0+22], %r1		; PC *anti-interlock*
	ld.h	[%r0],%r1
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r2+5]
	ld.ub	%r11,[%r2]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	;
	add	%sp,0x1		; 	xadd %sp, %sp, 4
	popn %r2
	ret

	
	.code
	.align 1
	.global z80op_DD
z80op_DD:
	pushn %r2
	sub	%sp,0x1		; 	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; z80
	ext	0x16		; 	xld.uh %r1, [%r0+22]		; PC
	ld.uh	%r1,[%r0]
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; code = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r13, %r10
	;
	ext	z80_op_table_DD+0x0@h	; 	xld.w %r2, z80_op_table_DD	; op = &z80_op_table_DD[code]
	ext	z80_op_table_DD+0x0@m
	ld.w	%r2,z80_op_table_DD+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r2, %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r2+4]		; argc == 0 ?
	ld.ub	%r10,[%r2]
	cmp	%r10,0x0	; 	xcmp %r10, 0	
	jreq	z80op_DD_L10	; 	xjreq z80op_DD_L10
	ld.b	[%sp+0x0],%r13	; 	xld.b [%sp+0], %r13		; (save code)
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; arg1 = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r14, %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r2+4]		; argc == 1 ?
	ld.ub	%r10,[%r2]
	cmp	%r10,0x1	; 	xcmp %r10, 1	
	jreq	z80op_DD_L20	; 	xjreq z80op_DD_L20
	ld.b	[%sp+0x1],%r14	; 	xld.b [%sp+1], %r14		; (save arg1)
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; arg2 = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.w %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r15, %r10
	;
	ld.ub	%r14,[%sp+0x1]	; 	xld.ub %r14, [%sp+1]		; (restore arg1)
z80op_DD_L20:
	ld.ub	%r13,[%sp+0x0]	; 	xld.ub %r13, [%sp+0]		; (restore code)
z80op_DD_L10:
	;
	ld.w	%r10,[%r2]	; 	xld.w %r10, [%r2+0]		; op->proc(z80, code, arg1, arg2)
	ext	0x16		; 	xld.h [%r0+22], %r1		; PC *anti-interlock*
	ld.h	[%r0],%r1
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r2+5]
	ld.ub	%r11,[%r2]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	;
	add	%sp,0x1		; 	xadd %sp, %sp, 4
	popn %r2
	ret

	
	.code
	.align 1
	.global z80op_FD
z80op_FD:
	pushn %r2
	sub	%sp,0x1		; 	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; z80
	ext	0x16		; 	xld.uh %r1, [%r0+22]		; PC
	ld.uh	%r1,[%r0]
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; code = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r13, %r10
	;
	ext	z80_op_table_FD+0x0@h	; 	xld.w %r2, z80_op_table_FD	; op = &z80_op_table_FD[code]
	ext	z80_op_table_FD+0x0@m
	ld.w	%r2,z80_op_table_FD+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r2, %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r2+4]		; argc == 0 ?
	ld.ub	%r10,[%r2]
	cmp	%r10,0x0	; 	xcmp %r10, 0	
	jreq	z80op_FD_L10	; 	xjreq z80op_FD_L10
	ld.b	[%sp+0x0],%r13	; 	xld.b [%sp+0], %r13		; (save code)
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; arg1 = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r14, %r10
	;
	ext	0x4		; 	xld.ub %r10, [%r2+4]		; argc == 1 ?
	ld.ub	%r10,[%r2]
	cmp	%r10,0x1	; 	xcmp %r10, 1	
	jreq	z80op_FD_L20	; 	xjreq z80op_FD_L20
	ld.b	[%sp+0x1],%r14	; 	xld.b [%sp+1], %r14		; (save arg1)
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; arg2 = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.w %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r15, %r10
	;
	ld.ub	%r14,[%sp+0x1]	; 	xld.ub %r14, [%sp+1]		; (restore arg1)
z80op_FD_L20:
	ld.ub	%r13,[%sp+0x0]	; 	xld.ub %r13, [%sp+0]		; (restore code)
z80op_FD_L10:
	;
	ld.w	%r10,[%r2]	; 	xld.w %r10, [%r2+0]		; op->proc(z80, code, arg1, arg2)
	ext	0x16		; 	xld.h [%r0+22], %r1		; PC *anti-interlock*
	ld.h	[%r0],%r1
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r2+5]
	ld.ub	%r11,[%r2]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	;
	add	%sp,0x1		; 	xadd %sp, %sp, 4
	popn %r2
	ret

	
	.code
	.align 1
	.global z80op_DDCB
z80op_DDCB:
	pushn %r2
	sub	%sp,0x1		; 	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; z80
	ext	0x16		; 	xld.uh %r1, [%r0+22]		; PC
	ld.uh	%r1,[%r0]
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; arg1 = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.b	[%sp+0x0],%r10	; 	xld.b [%sp+0], %r10		; (save arg1)
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; code = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r13, %r10
	;
	ext	z80_op_table_DDCB+0x0@h	; 	xld.w %r2, z80_op_table_DDCB	; op = &z80_op_table_DDCB[code]
	ext	z80_op_table_DDCB+0x0@m
	ld.w	%r2,z80_op_table_DDCB+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r2, %r10
	;
	ld.ub	%r14,[%sp+0x0]	; 	xld.ub %r14, [%sp+0]		; (restore arg1)
	;
	ld.w	%r10,[%r2]	; 	xld.w %r10, [%r2+0]		; op->proc(z80, code, arg1, arg2)
	ext	0x16		; 	xld.h [%r0+22], %r1		; PC *anti-interlock*
	ld.h	[%r0],%r1
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r2+5]
	ld.ub	%r11,[%r2]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	;
	add	%sp,0x1		; 	xadd %sp, %sp, 4
	popn %r2
	ret

	
	.code
	.align 1
	.global z80op_FDCB
z80op_FDCB:
	pushn %r2
	sub	%sp,0x1		; 	xsub %sp, %sp, 4
	;
	ld.w %r0, %r12			; z80
	ext	0x16		; 	xld.uh %r1, [%r0+22]		; PC
	ld.uh	%r1,[%r0]
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; arg1 = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.b	[%sp+0x0],%r10	; 	xld.b [%sp+0], %r10		; (save arg1)
	;
	ext	0x30		; 	xld.w %r11, [%r0+48]		; code = z80->read(z80, PC++)
	ld.w	%r11,[%r0]
	ld.w %r12, %r0
	ld.uh %r13, %r1
	call.d %r11
	add %r1, 1			; *delay*
	ld.ub %r13, %r10
	;
	ext	z80_op_table_FDCB+0x0@h	; 	xld.w %r2, z80_op_table_FDCB	; op = &z80_op_table_FDCB[code]
	ext	z80_op_table_FDCB+0x0@m
	ld.w	%r2,z80_op_table_FDCB+0x0@l
	sll	%r10,0x3	; 	xsll %r10, 3
	add %r2, %r10
	;
	ld.ub	%r14,[%sp+0x0]	; 	xld.ub %r14, [%sp+0]		; (restore arg1)
	;
	ld.w	%r10,[%r2]	; 	xld.w %r10, [%r2+0]		; op->proc(z80, code, arg1, arg2)
	ext	0x16		; 	xld.h [%r0+22], %r1		; PC *anti-interlock*
	ld.h	[%r0],%r1
	call.d %r10
	ld.w %r12, %r0			; *delay*
	;
	ext	0x24		; 	xld.w %r10, [%r0+36]		; CYCLE -= op->cycle
	ld.w	%r10,[%r0]
	ext	0x5		; 	xld.ub %r11, [%r2+5]
	ld.ub	%r11,[%r2]
	sub %r10, %r11
	ext	0x24		; 	xld.w [%r0+36], %r10
	ld.w	[%r0],%r10
	;
	add	%sp,0x1		; 	xadd %sp, %sp, 4
	popn %r2
	ret

	
	.code
	.align 1
	.global z80_PARITY
z80_PARITY:
	rr	%r12,0x8	; 	xrr %r12, 8			; ׂl8rbgɈړB
	jreq.d	z80_PARITY_L20	; 	xjreq.d z80_PARITY_L20		; 1̃rbgȂ΁A[vɓ܂B
	ld.w %r10, 4			; peBȂ̂ŁAԂONB*delay*
z80_PARITY_L10:
	scan1 %r11, %r12		; 1̃rbgʒuB(K݂)
	sll %r12, %r11			; rbgŏʂփVtgB
	sll %r12, 1			; rbg֎̂ĂB
	jrne.d	z80_PARITY_L10	; 	xjrne.d z80_PARITY_L10		; ܂1̃rbgcĂA[vB
	xor %r10, 4			; rbg̃peB]B*delay*
z80_PARITY_L20:
	ret

	
	.code			; C33(C,V,Z,N) => Z80(S,Z,V,C)
	.global z80_FLAG_CONV	; ====C33====     ====Z80====
z80_FLAG_CONV:			; ----CVZN        SZ---V-C   
	.byte	0x00		; 00000000 00     00000000 00
	.byte	0x80		; 00000001 01     10000000 80
	.byte	0x40		; 00000010 02     01000000 40
	.byte	0xc0		; 00000011 03     11000000 c0
	.byte	0x04		; 00000100 04     00000100 04
	.byte	0x84		; 00000101 05     10000100 84
	.byte	0x44		; 00000110 06     01000100 44
	.byte	0xc4		; 00000111 07     11000100 c4
	.byte	0x01		; 00001000 08     00000001 01
	.byte	0x81		; 00001001 09     10000001 81
	.byte	0x41		; 00001010 0a     01000001 41
	.byte	0xc1		; 00001011 0b     11000001 c1
	.byte	0x05		; 00001100 0c     00000101 05
	.byte	0x85		; 00001101 0d     10000101 85
	.byte	0x45		; 00001110 0e     01000101 45
	.byte	0xc5		; 00001111 0f     11000101 c5

	
	.code
	.align 1
	.global z80_ADD8
z80_ADD8:
	ext	0x1		; 	xld.ub %r14, [%r12+1]			; A
	ld.ub	%r14,[%r12]
	ld.w %r11, %r13				; *anti-interlock*
	ld.w %r10, %r14
	rr	%r11,0x8	; 	xrr %r11, 8
	rr	%r10,0x8	; 	xrr %r10, 8
	add %r10, %r11
	;
	ld.w %r11, %psr				; F(S,Z,V,C)
	and	%r11,0xf	; 	xand %r11, %r11, 0xf
	ext	z80_FLAG_CONV+0x0@h	; 	xld.ub %r11, [%r11+z80_FLAG_CONV]
	ext	z80_FLAG_CONV+0x0@m
	ld.w	%r9,z80_FLAG_CONV+0x0@l
	add	%r9,%r11
	ld.ub	%r11,[%r9]
	;
	rl	%r10,0x8	; 	xrl %r10, 8
	ext	0x1		; 	xld.b [%r12+1], %r10			; A
	ld.b	[%r12],%r10
	;
	ext	0x0		; 	xand %r10, %r10, 0x28			; F(Y,X)
	and	%r10,0x28
	or %r11, %r10
	;
	and	%r14,0xf	; 	xand %r14, %r14, 0xf			; F(H)
	and	%r13,0xf	; 	xand %r13, %r13, 0xf
	add %r14, %r13
	and	%r14,0x10	; 	xand %r14, %r14, 0x10
	or %r11, %r14
	;
	ld.b	[%r12],%r11	; 	xld.b [%r12+0], %r11			; F
	;
	ret

; NO_APP
	.code
	.align	1
	.global	z80_ADC8
z80_ADC8:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.w	%r5,%r12
	ld.ub	%r15,[%r5]	; 	xld.ub	%r15,[%r5]
	and	%r15,0x1	; 	xand	%r15,%r15,0x00000001
	ext	0x1		; 	xld.ub	%r11,[%r5+1]
	ld.ub	%r11,[%r5]
	ld.ub	%r14,%r11
	ld.ub	%r10,%r13
	ld.w	%r7,%r14
	add	%r7,%r10
	ld.w	%r10,%r7
	ld.w	%r4,%r10
	add	%r4,%r15
	ld.w	%r6,%r4
	ext	0x2		; 	xand	%r6,%r6,0x000000a8
	and	%r6,0x28
	ld.w	%r10,%r11
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.w	%r12,%r13
	and	%r12,0xf	; 	xand	%r12,%r12,0x0000000f
	add	%r10,%r12
	add	%r10,%r15
	ld.w	%r15,%r10
	and	%r15,0x10	; 	xand	%r15,%r15,0x00000010
	xor	%r11,%r13
	ld.ub	%r11,%r11
	not	%r11,%r11
	xor	%r14,%r4
	and	%r11,%r14
	ext	0x2		; 	xand	%r11,%r11,0x00000080
	and	%r11,0x0
	sra	%r11,0x5	; 	xsra	%r11,5
	ld.w	%r10,%r4
	sra	%r10,0x8	; 	xsra	%r10,8
	ld.w	%r12,%r10
	and	%r12,0x1	; 	xand	%r12,%r12,0x00000001
	ld.ub	%r10,%r4
	cmp	%r10,0x0
	jrne	__LX27		; 	xjrne	__L27
	ld.w	%r10,%r15
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r6,%r10
	ld.w	%r10,%r6
	jp	__LX29		; 	xjp	__L29
__LX27:				; __L27:
	ld.w	%r10,%r6
	or	%r10,%r15
__LX29:				; __L29:
	or	%r10,%r11
	or	%r10,%r12
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
	ext	0x1		; 	xld.b	[%r5+1],%r4
	ld.b	[%r5],%r4
	ret
; APP
	
	.code
	.align 1
	.global z80_SUB8
z80_SUB8:
	ext	0x1		; 	xld.ub %r14, [%r12+1]			; A
	ld.ub	%r14,[%r12]
	ld.w %r11, %r13				; *anti-interlock*
	ld.w %r10, %r14
	rr	%r11,0x8	; 	xrr %r11, 8
	rr	%r10,0x8	; 	xrr %r10, 8
	sub %r10, %r11
	;
	ld.w %r11, %psr				; F(S,Z,V,C)
	and	%r11,0xf	; 	xand %r11, %r11, 0xf
	ext	z80_FLAG_CONV+0x0@h	; 	xld.ub %r11, [%r11+z80_FLAG_CONV]
	ext	z80_FLAG_CONV+0x0@m
	ld.w	%r9,z80_FLAG_CONV+0x0@l
	add	%r9,%r11
	ld.ub	%r11,[%r9]
	;
	rl	%r10,0x8	; 	xrl %r10, 8
	ext	0x1		; 	xld.b [%r12+1], %r10			; A
	ld.b	[%r12],%r10
	;
	ext	0x0		; 	xand %r10, %r10, 0x28			; F(Y,X)
	and	%r10,0x28
	or %r11, %r10
	;
	and	%r14,0xf	; 	xand %r14, %r14, 0xf			; F(H)
	and	%r13,0xf	; 	xand %r13, %r13, 0xf
	sub %r14, %r13
	and	%r14,0x10	; 	xand %r14, %r14, 0x10
	or %r11, %r14
	;
	xor %r11, 2				; F(N)
	;
	ld.b	[%r12],%r11	; 	xld.b [%r12+0], %r11			; F
	;
	ret

; NO_APP
	.align	1
	.global	z80_SBC8
z80_SBC8:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.w	%r5,%r12
	ld.ub	%r15,[%r5]	; 	xld.ub	%r15,[%r5]
	and	%r15,0x1	; 	xand	%r15,%r15,0x00000001
	ext	0x1		; 	xld.ub	%r11,[%r5+1]
	ld.ub	%r11,[%r5]
	ld.ub	%r14,%r11
	ld.ub	%r10,%r13
	ld.w	%r7,%r14
	sub	%r7,%r10
	ld.w	%r10,%r7
	ld.w	%r4,%r10
	sub	%r4,%r15
	ld.w	%r6,%r4
	ext	0x2		; 	xand	%r6,%r6,0x000000a8
	and	%r6,0x28
	ld.w	%r10,%r11
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.w	%r12,%r13
	and	%r12,0xf	; 	xand	%r12,%r12,0x0000000f
	sub	%r10,%r12
	sub	%r10,%r15
	ld.w	%r15,%r10
	and	%r15,0x10	; 	xand	%r15,%r15,0x00000010
	xor	%r11,%r13
	ld.ub	%r11,%r11
	xor	%r14,%r4
	and	%r11,%r14
	ext	0x2		; 	xand	%r11,%r11,0x00000080
	and	%r11,0x0
	sra	%r11,0x5	; 	xsra	%r11,5
	ld.w	%r10,%r4
	sra	%r10,0x8	; 	xsra	%r10,8
	ld.w	%r12,%r10
	and	%r12,0x1	; 	xand	%r12,%r12,0x00000001
	ld.ub	%r10,%r4
	cmp	%r10,0x0
	jrne	__LX31		; 	xjrne	__L31
	ld.w	%r10,%r15
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r6,%r10
	ld.w	%r10,%r6
	jp	__LX33		; 	xjp	__L33
__LX31:				; __L31:
	ld.w	%r10,%r6
	or	%r10,%r15
__LX33:				; __L33:
	or	%r10,%r11
	ld.w	%r11,%r12
	or	%r11,0x2	; 	xoor	%r11,%r11,0x00000002
	or	%r10,%r11
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
	ext	0x1		; 	xld.b	[%r5+1],%r4
	ld.b	[%r5],%r4
	ret
	.align	1
	.global	z80_AND
z80_AND:
;	.frame	%sp,12,$31		# vars= 0, regs= 3/0, args= 0, extra= 0
;	.mask	0x80030000,-4
;	.fmask	0x00000000,0
	pushn	%r1
	ld.w	%r0,%r12
	ext	0x1		; 	xld.ub	%r12,[%r0+1]
	ld.ub	%r12,[%r0]
	and	%r12,%r13
	ext	0x1		; 	xld.b	[%r0+1],%r12
	ld.b	[%r0],%r12
	ld.w	%r1,%r12
	ext	0x2		; 	xand	%r1,%r1,0x000000a8
	and	%r1,0x28
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r11,%r10
	ext	0x1		; 	xld.ub	%r10,[%r0+1]
	ld.ub	%r10,[%r0]
	cmp	%r10,0x0
	jrne	__LX35		; 	xjrne	__L35
	ld.w	%r10,%r11
	ext	0x1		; 	xoor	%r10,%r10,0x00000050
	or	%r10,0x10
	jp	__LX37		; 	xjp	__L37
__LX35:				; __L35:
	ld.w	%r10,%r11
	or	%r10,0x10	; 	xoor	%r10,%r10,0x00000010
__LX37:				; __L37:
	or	%r1,%r10
	ld.w	%r10,%r1
	ld.b	[%r0],%r10	; 	xld.b	[%r0],%r10
	popn	%r1
	ret
	.align	1
	.global	z80_OR
z80_OR:
;	.frame	%sp,12,$31		# vars= 0, regs= 3/0, args= 0, extra= 0
;	.mask	0x80030000,-4
;	.fmask	0x00000000,0
	pushn	%r1
	ld.w	%r0,%r12
	ext	0x1		; 	xld.ub	%r12,[%r0+1]
	ld.ub	%r12,[%r0]
	or	%r12,%r13
	ext	0x1		; 	xld.b	[%r0+1],%r12
	ld.b	[%r0],%r12
	ld.w	%r1,%r12
	ext	0x2		; 	xand	%r1,%r1,0x000000a8
	and	%r1,0x28
	ld.ub	%r12,%r12
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r11,%r10
	ext	0x1		; 	xld.ub	%r10,[%r0+1]
	ld.ub	%r10,[%r0]
	cmp	%r10,0x0
	jrne	__LX39		; 	xjrne	__L39
	ld.w	%r10,%r11
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r1,%r10
	ld.w	%r10,%r1
	jp	__LX40		; 	xjp	__L40
__LX39:				; __L39:
	ld.w	%r10,%r1
	or	%r10,%r11
__LX40:				; __L40:
	ld.b	[%r0],%r10	; 	xld.b	[%r0],%r10
	popn	%r1
	ret
	.align	1
	.global	z80_XOR
z80_XOR:
;	.frame	%sp,12,$31		# vars= 0, regs= 3/0, args= 0, extra= 0
;	.mask	0x80030000,-4
;	.fmask	0x00000000,0
	pushn	%r1
	ld.w	%r0,%r12
	ext	0x1		; 	xld.ub	%r12,[%r0+1]
	ld.ub	%r12,[%r0]
	xor	%r12,%r13
	ext	0x1		; 	xld.b	[%r0+1],%r12
	ld.b	[%r0],%r12
	ld.w	%r1,%r12
	ext	0x2		; 	xand	%r1,%r1,0x000000a8
	and	%r1,0x28
	ld.ub	%r12,%r12
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r11,%r10
	ext	0x1		; 	xld.ub	%r10,[%r0+1]
	ld.ub	%r10,[%r0]
	cmp	%r10,0x0
	jrne	__LX42		; 	xjrne	__L42
	ld.w	%r10,%r11
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r1,%r10
	ld.w	%r10,%r1
	jp	__LX43		; 	xjp	__L43
__LX42:				; __L42:
	ld.w	%r10,%r1
	or	%r10,%r11
__LX43:				; __L43:
	ld.b	[%r0],%r10	; 	xld.b	[%r0],%r10
	popn	%r1
	ret
	.align	1
	.global	z80_CP
z80_CP:
;	.frame	%sp,8,$31		# vars= 0, regs= 2/0, args= 0, extra= 0
;	.mask	0x80010000,-4
;	.fmask	0x00000000,0
	pushn	%r0
	ld.w	%r6,%r12
	ext	0x1		; 	xld.ub	%r11,[%r6+1]
	ld.ub	%r11,[%r6]
	ld.ub	%r15,%r11
	ld.ub	%r14,%r13
	ld.w	%r0,%r15
	sub	%r0,%r14
	ld.w	%r14,%r0
	ext	0x2		; 	xld.w	%r4,0x00000080		; 128
	ld.w	%r4,0x0
	ld.w	%r12,%r14
	and	%r12,%r4
	ld.w	%r10,%r13
	ext	0x0		; 	xand	%r10,%r10,0x00000028
	and	%r10,0x28
	ld.w	%r7,%r12
	or	%r7,%r10
	ld.w	%r10,%r11
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	ld.w	%r12,%r13
	and	%r12,0xf	; 	xand	%r12,%r12,0x0000000f
	sub	%r10,%r12
	ld.w	%r5,%r10
	and	%r5,0x10	; 	xand	%r5,%r5,0x00000010
	xor	%r11,%r13
	ld.ub	%r11,%r11
	xor	%r15,%r14
	and	%r11,%r15
	and	%r11,%r4
	sra	%r11,0x5	; 	xsra	%r11,5
	ld.w	%r10,%r14
	sra	%r10,0x8	; 	xsra	%r10,8
	ld.w	%r12,%r10
	and	%r12,0x1	; 	xand	%r12,%r12,0x00000001
	ld.ub	%r14,%r14
	cmp	%r14,0x0
	jrne	__LX45		; 	xjrne	__L45
	ld.w	%r10,%r5
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r7,%r10
	ld.w	%r10,%r7
	jp	__LX47		; 	xjp	__L47
__LX45:				; __L45:
	ld.w	%r10,%r7
	or	%r10,%r5
__LX47:				; __L47:
	or	%r10,%r11
	ld.w	%r11,%r12
	or	%r11,0x2	; 	xoor	%r11,%r11,0x00000002
	or	%r10,%r11
	ld.b	[%r6],%r10	; 	xld.b	[%r6],%r10
	popn	%r0
	ret
	.align	1
	.global	z80_INC8
z80_INC8:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	add	%r13,0x1	; 	xadd	%r13,%r13,1
	ld.w	%r15,%r13
	ld.w	%r10,%r13
	ext	0x2		; 	xand	%r10,%r10,0x000000a8
	and	%r10,0x28
	ld.ub	%r14,%r15
	cmp	%r14,0x0
	jrne	__LX49		; 	xjrne	__L49
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
__LX49:				; __L49:
	ld.w	%r11,%r10
	ld.w	%r10,%r13
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	jrne	__LX50		; 	xjrne	__L50
	or	%r11,0x10	; 	xoor	%r11,%r11,0x00000010
__LX50:				; __L50:
	ld.ub	%r10,[%r12]	; 	xld.ub	%r10,[%r12]
	and	%r10,0x1	; 	xand	%r10,%r10,0x00000001
	ext	0x2		; 	xcmp	%r14,128
	cmp	%r14,0x0
	jrne	__LX51		; 	xjrne	__L51
	or	%r10,0x4	; 	xoor	%r10,%r10,0x00000004
__LX51:				; __L51:
	or	%r11,%r10
	ld.w	%r10,%r11
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
	ld.ub	%r10,%r15
	ret
	.align	1
	.global	z80_DEC8
z80_DEC8:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	sub	%r13,0x1	; 	xsub	%r13,%r13,1
	ld.w	%r15,%r13
	ld.w	%r10,%r13
	ext	0x2		; 	xand	%r10,%r10,0x000000a8
	and	%r10,0x28
	ld.ub	%r14,%r15
	cmp	%r14,0x0
	jrne	__LX54		; 	xjrne	__L54
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
__LX54:				; __L54:
	ld.w	%r11,%r10
	ld.w	%r10,%r13
	and	%r10,0xf	; 	xand	%r10,%r10,0x0000000f
	cmp	%r10,0xf	; 	xcmp	%r10,15
	jrne	__LX55		; 	xjrne	__L55
	or	%r11,0x10	; 	xoor	%r11,%r11,0x00000010
__LX55:				; __L55:
	ld.ub	%r10,[%r12]	; 	xld.ub	%r10,[%r12]
	and	%r10,0x1	; 	xand	%r10,%r10,0x00000001
	ext	0x1		; 	xcmp	%r14,127
	cmp	%r14,0x3f
	jrne	__LX56		; 	xjrne	__L56
	or	%r10,0x6	; 	xoor	%r10,%r10,0x00000006
	jp	__LX58		; 	xjp	__L58
__LX56:				; __L56:
	or	%r10,0x2	; 	xoor	%r10,%r10,0x00000002
__LX58:				; __L58:
	or	%r11,%r10
	ld.w	%r10,%r11
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
	ld.ub	%r10,%r15
	ret
	.align	1
	.global	z80_ADD16
z80_ADD16:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.uh	%r10,%r13
	ld.uh	%r11,%r14
	add	%r10,%r11
	ld.ub	%r4,[%r12]	; 	xld.ub	%r4,[%r12]
	ext	0x3		; 	xand	%r4,%r4,0x000000c4
	and	%r4,0x4
	ld.w	%r11,%r10
	sra	%r11,0x8	; 	xsra	%r11,8
	ext	0x0		; 	xand	%r11,%r11,0x00000028
	and	%r11,0x28
	or	%r4,%r11
	ext	0x3f		; 	xld.w	%r15,0x00000fff		; 4095
	ld.w	%r15,0x3f
	ld.w	%r11,%r15
	and	%r11,%r13
	and	%r15,%r14
	add	%r11,%r15
	sra	%r11,0x8	; 	xsra	%r11,8
	and	%r11,0x10	; 	xand	%r11,%r11,0x00000010
	or	%r4,%r11
	ld.w	%r11,%r10
	srl	%r11,0x8	; 	xsrl	%r11,16
	srl	%r11,0x8
	or	%r4,%r11
	ld.b	[%r12],%r4	; 	xld.b	[%r12],%r4
	ld.uh	%r10,%r10
	ret
	.align	1
	.global	z80_ADC16
z80_ADC16:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.w	%r5,%r12
	ld.ub	%r15,[%r5]	; 	xld.ub	%r15,[%r5]
	and	%r15,0x1	; 	xand	%r15,%r15,0x00000001
	ld.uh	%r12,%r13
	ld.uh	%r10,%r14
	ld.w	%r7,%r12
	add	%r7,%r10
	ld.w	%r10,%r7
	ld.w	%r4,%r10
	add	%r4,%r15
	ld.w	%r10,%r4
	sra	%r10,0x8	; 	xsra	%r10,8
	ld.w	%r6,%r10
	ext	0x2		; 	xand	%r6,%r6,0x000000a8
	and	%r6,0x28
	ext	0x3f		; 	xld.w	%r11,0x00000fff		; 4095
	ld.w	%r11,0x3f
	ld.w	%r10,%r11
	and	%r10,%r13
	and	%r11,%r14
	add	%r10,%r11
	add	%r10,%r15
	sra	%r10,0x8	; 	xsra	%r10,8
	ld.w	%r15,%r10
	and	%r15,0x10	; 	xand	%r15,%r15,0x00000010
	xor	%r13,%r14
	ld.uh	%r13,%r13
	not	%r13,%r13
	xor	%r12,%r4
	and	%r13,%r12
	ext	0x200		; 	xand	%r13,%r13,0x00008000
	and	%r13,0x0
	sra	%r13,0x8	; 	xsra	%r13,13
	sra	%r13,0x5
	ld.w	%r10,%r4
	sra	%r10,0x8	; 	xsra	%r10,16
	sra	%r10,0x8
	ld.w	%r11,%r10
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	ld.uh	%r10,%r4
	cmp	%r10,0x0
	jrne	__LX61		; 	xjrne	__L61
	ld.w	%r10,%r15
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r6,%r10
	ld.w	%r10,%r6
	jp	__LX63		; 	xjp	__L63
__LX61:				; __L61:
	ld.w	%r10,%r6
	or	%r10,%r15
__LX63:				; __L63:
	or	%r10,%r13
	or	%r10,%r11
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
	ld.uh	%r10,%r4
	ret
	.align	1
	.global	z80_SBC16
z80_SBC16:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.w	%r5,%r12
	ld.ub	%r15,[%r5]	; 	xld.ub	%r15,[%r5]
	and	%r15,0x1	; 	xand	%r15,%r15,0x00000001
	ld.uh	%r12,%r13
	ld.uh	%r10,%r14
	ld.w	%r7,%r12
	sub	%r7,%r10
	ld.w	%r10,%r7
	ld.w	%r4,%r10
	sub	%r4,%r15
	ld.w	%r10,%r4
	sra	%r10,0x8	; 	xsra	%r10,8
	ld.w	%r6,%r10
	ext	0x2		; 	xand	%r6,%r6,0x000000a8
	and	%r6,0x28
	ext	0x3f		; 	xld.w	%r11,0x00000fff		; 4095
	ld.w	%r11,0x3f
	ld.w	%r10,%r11
	and	%r10,%r13
	and	%r11,%r14
	sub	%r10,%r11
	sub	%r10,%r15
	sra	%r10,0x8	; 	xsra	%r10,8
	ld.w	%r15,%r10
	and	%r15,0x10	; 	xand	%r15,%r15,0x00000010
	xor	%r13,%r14
	ld.uh	%r13,%r13
	xor	%r12,%r4
	and	%r13,%r12
	ext	0x200		; 	xand	%r13,%r13,0x00008000
	and	%r13,0x0
	sra	%r13,0x8	; 	xsra	%r13,13
	sra	%r13,0x5
	ld.w	%r10,%r4
	sra	%r10,0x8	; 	xsra	%r10,16
	sra	%r10,0x8
	ld.w	%r11,%r10
	and	%r11,0x1	; 	xand	%r11,%r11,0x00000001
	ld.uh	%r10,%r4
	cmp	%r10,0x0
	jrne	__LX65		; 	xjrne	__L65
	ld.w	%r10,%r15
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
	or	%r6,%r10
	ld.w	%r10,%r6
	jp	__LX67		; 	xjp	__L67
__LX65:				; __L65:
	ld.w	%r10,%r6
	or	%r10,%r15
__LX67:				; __L67:
	or	%r10,%r13
	or	%r11,0x2	; 	xoor	%r11,%r11,0x00000002
	or	%r10,%r11
	ld.b	[%r5],%r10	; 	xld.b	[%r5],%r10
	ld.uh	%r10,%r4
	ret
	.align	1
	.global	z80_RL
z80_RL:
;	.frame	%sp,24,$31		# vars= 4, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x1		; 	xsub	%sp,%sp,4
	ld.w	%r2,%r12
	ld.w	%r0,%r13
	sll	%r13,0x1	; 	xsll	%r13,1
	ld.ub	%r10,[%r2]	; 	xld.ub	%r10,[%r2]
	and	%r10,0x1	; 	xand	%r10,%r10,0x00000001
	or	%r13,%r10
	ld.b	[%sp+0x0],%r13	; 	xld.b	[%sp],%r13
	ld.w	%r3,%r13
	ext	0x2		; 	xand	%r3,%r3,0x000000a8
	and	%r3,0x28
	ld.ub	%r1,[%sp+0x0]	; 	xld.ub	%r1,[%sp]
	ld.w	%r12,%r1
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r10,%r10
	ld.ub	%r0,%r0
	srl	%r0,0x7		; 	xsrl	%r0,7
	cmp	%r1,0x0
	jrne	__LX69		; 	xjrne	__L69
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
__LX69:				; __L69:
	or	%r3,%r10
	ld.w	%r10,%r3
	or	%r10,%r0
	ld.b	[%r2],%r10	; 	xld.b	[%r2],%r10
	ld.ub	%r10,[%sp+0x0]	; 	xld.ub	%r10,[%sp]
	add	%sp,0x1		; 	xadd	%sp,%sp,4
	popn	%r3
	ret
	.align	1
	.global	z80_RLC
z80_RLC:
;	.frame	%sp,24,$31		# vars= 4, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x1		; 	xsub	%sp,%sp,4
	ld.w	[%sp+0x0],%r12	; 	xld.w	[%sp],%r12
	ld.ub	%r0,%r13
	srl	%r0,0x7		; 	xsrl	%r0,7
	sll	%r13,0x1	; 	xsll	%r13,1
	ld.w	%r10,%r0
	or	%r10,%r13
	ld.w	%r3,%r10
	ld.w	%r2,%r10
	ext	0x2		; 	xand	%r2,%r2,0x000000a8
	and	%r2,0x28
	ld.ub	%r1,%r3
	ld.w	%r12,%r1
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r10,%r10
	ld.ub	%r0,%r0
	cmp	%r1,0x0
	jrne	__LX72		; 	xjrne	__L72
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
__LX72:				; __L72:
	or	%r2,%r10
	ld.w	%r10,%r2
	or	%r10,%r0
	ld.w	%r11,[%sp+0x0]	; 	xld.w	%r11,[%sp]
	ld.b	[%r11],%r10	; 	xld.b	[%r11],%r10
	ld.ub	%r10,%r3
	add	%sp,0x1		; 	xadd	%sp,%sp,4
	popn	%r3
	ret
	.align	1
	.global	z80_RR
z80_RR:
;	.frame	%sp,24,$31		# vars= 4, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x1		; 	xsub	%sp,%sp,4
	ld.w	%r2,%r12
	ld.w	%r1,%r13
	ld.ub	%r10,%r1
	srl	%r10,0x1	; 	xsrl	%r10,1
	ld.ub	%r11,[%r2]	; 	xld.ub	%r11,[%r2]
	sll	%r11,0x7	; 	xsll	%r11,7
	or	%r10,%r11
	ld.b	[%sp+0x0],%r10	; 	xld.b	[%sp],%r10
	ld.w	%r3,%r10
	ext	0x2		; 	xand	%r3,%r3,0x000000a8
	and	%r3,0x28
	ld.ub	%r0,[%sp+0x0]	; 	xld.ub	%r0,[%sp]
	ld.w	%r12,%r0
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r10,%r10
	and	%r1,0x1		; 	xand	%r1,%r1,0x00000001
	cmp	%r0,0x0
	jrne	__LX75		; 	xjrne	__L75
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
__LX75:				; __L75:
	or	%r3,%r10
	ld.w	%r10,%r3
	or	%r10,%r1
	ld.b	[%r2],%r10	; 	xld.b	[%r2],%r10
	ld.ub	%r10,[%sp+0x0]	; 	xld.ub	%r10,[%sp]
	add	%sp,0x1		; 	xadd	%sp,%sp,4
	popn	%r3
	ret
	.align	1
	.global	z80_RRC
z80_RRC:
;	.frame	%sp,24,$31		# vars= 4, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x1		; 	xsub	%sp,%sp,4
	ld.w	[%sp+0x0],%r12	; 	xld.w	[%sp],%r12
	ld.w	%r0,%r13
	ld.ub	%r10,%r0
	srl	%r10,0x1	; 	xsrl	%r10,1
	ld.w	%r11,%r0
	sll	%r11,0x7	; 	xsll	%r11,7
	or	%r10,%r11
	ld.w	%r3,%r10
	ld.w	%r2,%r10
	ext	0x2		; 	xand	%r2,%r2,0x000000a8
	and	%r2,0x28
	ld.ub	%r1,%r3
	ld.w	%r12,%r1
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r10,%r10
	and	%r0,0x1		; 	xand	%r0,%r0,0x00000001
	cmp	%r1,0x0
	jrne	__LX78		; 	xjrne	__L78
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
__LX78:				; __L78:
	or	%r2,%r10
	ld.w	%r10,%r2
	or	%r10,%r0
	ld.w	%r14,[%sp+0x0]	; 	xld.w	%r14,[%sp]
	ld.b	[%r14],%r10	; 	xld.b	[%r14],%r10
	ld.ub	%r10,%r3
	add	%sp,0x1		; 	xadd	%sp,%sp,4
	popn	%r3
	ret
	.align	1
	.global	z80_SLA
z80_SLA:
;	.frame	%sp,24,$31		# vars= 4, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x1		; 	xsub	%sp,%sp,4
	ld.w	[%sp+0x0],%r12	; 	xld.w	[%sp],%r12
	ld.w	%r0,%r13
	sll	%r13,0x1	; 	xsll	%r13,1
	ld.w	%r3,%r13
	ld.w	%r2,%r13
	ext	0x2		; 	xand	%r2,%r2,0x000000a8
	and	%r2,0x28
	ld.ub	%r1,%r3
	ld.w	%r12,%r1
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r10,%r10
	ld.ub	%r0,%r0
	srl	%r0,0x7		; 	xsrl	%r0,7
	cmp	%r1,0x0
	jrne	__LX81		; 	xjrne	__L81
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
__LX81:				; __L81:
	or	%r2,%r10
	ld.w	%r10,%r2
	or	%r10,%r0
	ld.w	%r11,[%sp+0x0]	; 	xld.w	%r11,[%sp]
	ld.b	[%r11],%r10	; 	xld.b	[%r11],%r10
	ld.ub	%r10,%r3
	add	%sp,0x1		; 	xadd	%sp,%sp,4
	popn	%r3
	ret
	.align	1
	.global	z80_SRA
z80_SRA:
;	.frame	%sp,24,$31		# vars= 4, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x1		; 	xsub	%sp,%sp,4
	ld.w	[%sp+0x0],%r12	; 	xld.w	[%sp],%r12
	ld.w	%r0,%r13
	ld.b	%r10,%r0
	sra	%r10,0x1	; 	xsra	%r10,1
	ld.w	%r3,%r10
	ld.w	%r2,%r10
	ext	0x2		; 	xand	%r2,%r2,0x000000a8
	and	%r2,0x28
	ld.ub	%r1,%r3
	ld.w	%r12,%r1
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r10,%r10
	and	%r0,0x1		; 	xand	%r0,%r0,0x00000001
	cmp	%r1,0x0
	jrne	__LX84		; 	xjrne	__L84
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
__LX84:				; __L84:
	or	%r2,%r10
	ld.w	%r10,%r2
	or	%r10,%r0
	ld.w	%r11,[%sp+0x0]	; 	xld.w	%r11,[%sp]
	ld.b	[%r11],%r10	; 	xld.b	[%r11],%r10
	ld.ub	%r10,%r3
	add	%sp,0x1		; 	xadd	%sp,%sp,4
	popn	%r3
	ret
	.align	1
	.global	z80_SRL
z80_SRL:
;	.frame	%sp,24,$31		# vars= 4, regs= 5/0, args= 0, extra= 0
;	.mask	0x800f0000,-4
;	.fmask	0x00000000,0
	pushn	%r3
	sub	%sp,0x1		; 	xsub	%sp,%sp,4
	ld.w	[%sp+0x0],%r12	; 	xld.w	[%sp],%r12
	ld.w	%r0,%r13
	ld.ub	%r10,%r0
	srl	%r10,0x1	; 	xsrl	%r10,1
	ld.w	%r3,%r10
	ld.w	%r2,%r10
	ext	0x0		; 	xand	%r2,%r2,0x00000028
	and	%r2,0x28
	ld.ub	%r1,%r3
	ld.w	%r12,%r1
	ext	z80_PARITY@rm	; 	xcall	z80_PARITY
	call	z80_PARITY@rl
	ld.ub	%r10,%r10
	and	%r0,0x1		; 	xand	%r0,%r0,0x00000001
	cmp	%r1,0x0
	jrne	__LX87		; 	xjrne	__L87
	ext	0x1		; 	xoor	%r10,%r10,0x00000040
	or	%r10,0x0
__LX87:				; __L87:
	or	%r2,%r10
	ld.w	%r10,%r2
	or	%r10,%r0
	ld.w	%r11,[%sp+0x0]	; 	xld.w	%r11,[%sp]
	ld.b	[%r11],%r10	; 	xld.b	[%r11],%r10
	ld.ub	%r10,%r3
	add	%sp,0x1		; 	xadd	%sp,%sp,4
	popn	%r3
	ret
	.align	1
	.global	z80_BIT
z80_BIT:
;	.frame	%sp,4,$31		# vars= 0, regs= 1/0, args= 0, extra= 0
;	.mask	0x80000000,-4
;	.fmask	0x00000000,0
	ld.ub	%r13,%r13
	ld.w	%r10,0x1	; 	xld.w	%r10,0x00000001		; 1
	ld.w	%r9,%r13	; 	xsll	%r10,%r13
	and	%r9,0x1f
	cmp	%r9,0x8
	jrle	4
	sll	%r10,0x8
	jp.d	-3
	sub	%r9,0x8
	sll	%r10,%r9
	and	%r14,%r10
	ld.w	%r11,%r14
	ext	0x2		; 	xand	%r11,%r11,0x00000080
	and	%r11,0x0
	ld.ub	%r10,[%r12]	; 	xld.ub	%r10,[%r12]
	and	%r10,0x1	; 	xand	%r10,%r10,0x00000001
	ld.ub	%r14,%r14
	cmp	%r14,0x0
	jreq	__LX90		; 	xjreq	__L90
	or	%r10,0x10	; 	xoor	%r10,%r10,0x00000010
	jp	__LX92		; 	xjp	__L92
__LX90:				; __L90:
	ext	0x1		; 	xoor	%r10,%r10,0x00000054
	or	%r10,0x14
__LX92:				; __L92:
	or	%r11,%r10
	ld.w	%r10,%r11
	ld.b	[%r12],%r10	; 	xld.b	[%r12],%r10
	ret
